# AUTOGENERATED! DO NOT EDIT! File to edit: 03_pre.ipynb (unless otherwise specified).

__all__ = ['convert_playlists_x_tracks', 'convert_playlists_x_artists']

# Cell
import json
import csv
import pandas as pd

# Cell
def convert_playlists_x_tracks(path_base, path_save, n_playlists=10000):
    song_playlist_rows = []
    for i in range(0, n_playlists, 1000):
        path = f'{path_base}\mpd.slice.{i}-{i+999}.json'
        d = json.load(open(path, 'r'))
        mpd_slice = pd.DataFrame.from_dict(d['playlists'], orient='columns')
        for index, row in mpd_slice.iterrows():
            for track in row['tracks']:
                song_playlist_rows.append([row['pid'], track['track_uri'], 1, row['name'], track['track_name'], track['artist_uri'], track['artist_name']])
    mpd_df = pd.DataFrame(song_playlist_rows, columns=['pid', 'track_uri', 'rating', 'playlist_name', 'track_name', 'artist_uri','artist_name'])
    mpd_df.to_csv(f'{path_save}\mpd_slice_0-{n_playlists-1}.csv', index=False)
    return mpd_df

# Cell
def convert_playlists_x_artists(path_base, path_save, n_playlists=10000):
    artist_playlist_rows = []
    for i in range(0, n_playlists, 1000):
        path = f'{path_base}\mpd.slice.{i}-{i+999}.json'
        d = json.load(open(path, 'r'))
        mpd_slice = pd.DataFrame.from_dict(d['playlists'], orient='columns')
        for index, row in mpd_slice.iterrows():
            for track in row['tracks']:
                artist_playlist_rows.append([row['pid'], track['artist_uri'], 1, row['name'], track['artist_name'], track['track_uri'], track['track_name']])
    mpd_df = pd.DataFrame(artist_playlist_rows, columns=['pid', 'artist_uri', 'rating', 'playlist_name', 'artist_name', 'track_uri', 'track_name'])
    mpd_df.to_csv(f'{path_save}\playlists_x_artists_0-{n_playlists-1}.csv', index=False)
    return mpd_df